<?php
// guvenlik kodlarini dahil et
require_once 'inc/guvenlik.php';

// Silinecek komponent ID'sini al ve doğrula
if (isset($_POST['komponent_id']) && is_numeric($_POST['komponent_id'])) {
    $komponent_id = (int) $_POST['komponent_id']; // ID'yi tamsayıya dönüştürür

    try {
        // Komponenti silme sorgusu
        $query = "DELETE FROM komponent WHERE id = :komponent_id";
        $stmt = $baglantim->prepare($query);
        $stmt->bindParam(':komponent_id', $komponent_id, PDO::PARAM_INT);

        // Sorguyu çalıştır
        if ($stmt->execute()) {
            echo json_encode(["success" => true, "message" => "Komponent başarıyla silindi."]);
        } else {
            echo json_encode(["success" => false, "message" => "Silme işlemi sırasında bir hata oluştu."]);
        }
    } catch (PDOException $e) {
        // Hata durumunda
        // Hata mesajlarını kullanıcıya değil, log dosyasına yazdırabilirsiniz.
        error_log("Veritabanı hatası: " . $e->getMessage()); // Hata log dosyasına yazılır
        echo json_encode(["success" => false, "message" => "Bir hata oluştu. Lütfen tekrar deneyin."]);
    }
} else {
    echo json_encode(["success" => false, "message" => "Geçersiz komponent ID'si."]);
}
?>
