<?php
// guvenlik kodlarini dahil et
require_once 'inc/guvenlik.php';
?>


<style>

        h2 {
            font-weight: 600;
            color: #333;
            margin-bottom: 20px;
        }

        /* File Drop Area */
        .drop-area {
            border: 2px dashed #007bff;
            padding: 30px;
            text-align: center;
            /*cursor: pointer;*/
            border-radius: 10px;
            background-color: #fafafa;
            transition: all 0.3s ease;
        }

        .drop-area:hover {
            background-color: #e6f7ff;
            border-color: #0056b3;
        }

        .drop-area p {
            font-size: 14px;
            color: #007bff;
            margin: 0;
        }

        /* Browse Button */
        .btn-browse {
            display: inline-block;
            width: 100%;
            margin-top: 15px;
            padding: 10px;
            background-color: #007bff;
            color: white;
            border-radius: 8px;
            font-size: 14px;
            border: none;
            cursor: pointer;
            transition: background-color 0.3s ease;
        }

        .btn-browse:hover {
            background-color: #0056b3;
        }

        /* File Previews */
        .file-preview {
            display: inline-block;
            margin: 10px;
            width: 100px;
            text-align: center;
            background-color: #f1f1f1;
            padding: 10px;
            border-radius: 8px;
            transition: box-shadow 0.3s ease;
            position: relative;
            overflow: hidden;
        }

        .file-preview:hover {
            box-shadow: 0 4px 15px rgba(0, 123, 255, 0.2);
        }

        .file-preview img,
        .file-preview object {
            width: 60px;
            height: 60px;
            border-radius: 6px;
            object-fit: cover;
            margin-bottom: 8px;
        }

        .file-name {
            font-size: 12px;
            color: #333;
            margin-top: 8px;
            text-overflow: ellipsis;
            overflow: hidden;
            white-space: nowrap;
            max-width: 80px; /* Limit the length when not hovered */
            transition: all 0.3s ease;
            cursor: default;
        }

        .file-size {
            font-size: 10px;
            color: #777;
            margin-top: 4px;
        }

        /* Delete Button */
        .delete-btn {
            position: absolute;
            top: 5px;
            right: 5px;
            background: transparent;
            border: none;
            color: #e60000;
            font-size: 16px;
            cursor: pointer;
            opacity: 0;
            transition: opacity 0.3s ease, transform 0.3s ease;
        }

        /* Show delete button on hover */
        .file-preview:hover .delete-btn {
            opacity: 1;
            transform: scale(1.2);
        }

        /* Upload Button */
        #upload-btn {
            display: none;
            padding: 10px 18px;
            font-size: 14px;
            background-color: #007bff;
            color: white;
            border-radius: 8px;
            cursor: pointer;
            border: none;
            margin-top: 20px;
            width: 100%;
            transition: background-color 0.3s ease;
        }

        #upload-btn:hover {
            background-color: #0056b3;
        }

        /* Upload Response */
        .upload-response {
            margin-top: 20px;
            text-align: center;
        }

        .upload-response .alert {
            font-size: 14px;
            padding: 10px;
            margin-top: 20px;
        }

        /* Loading Spinner */
        .spinner {
            display: none;
            width: 40px;
            height: 40px;
            border: 4px solid rgba(0, 123, 255, 0.3);
            border-top: 4px solid #007bff;
            border-radius: 50%;
            animation: spin 1s linear infinite;
            margin-top: 10px;
        }

        @keyframes spin {
            0% { transform: rotate(0deg); }
            100% { transform: rotate(360deg); }
        }
    </style>

    <!-- Drop Area -->
    <div class="drop-area" id="drop-area">
        <p><i class="fas fa-cloud-upload-alt"></i> Dosyalarınızı buraya sürükleyip bırakın veya</p>
        <input type="file" id="file-input" multiple class="d-none">

    </div>

    <!-- Browse Button -->
    <button class="btn-browse" id="file-input-browse">Dosyalara Gözat</button>

    <!-- File Previews -->
    <div id="file-previews"></div>

    <!-- Upload Button -->
    <button id="upload-btn">Dosyaları yükle</button>

    <!-- Loading Spinner -->
    <div id="loading-spinner" class="spinner"></div>

    <!-- Upload Response -->
    <div id="upload-response" class="upload-response"></div>


<!-- Scripts -->
<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<script>
    // Trigger the file input dialog when the drop-area or browse button is clicked
    $('#file-input-browse').on('click', function() {
        // Directly trigger the file input click
        $('#file-input').click();
    });

    // Handle the drag over event
    $('#drop-area').on('dragover', function(e) {
        e.preventDefault();
        $(this).addClass('bg-light');
    }).on('dragleave', function() {
        $(this).removeClass('bg-light');
    });

    // Handle file drop event
    $('#drop-area').on('drop', function(e) {
        e.preventDefault();
        $(this).removeClass('bg-light');
        var files = e.originalEvent.dataTransfer.files;
        $('#file-input')[0].files = files;
        displayFilePreviews(files);
    });

    // Handle file input change event to display previews
    $('#file-input').on('change', function() {
        var files = this.files;
        displayFilePreviews(files);
    });

    // Display file previews and size
    function displayFilePreviews(files) {
        var filePreviews = '';
        $('#file-previews').html(''); // Clear previous previews

        $.each(files, function(index, file) {
            var fileSizeMB = (file.size / 1024 / 1024).toFixed(2); // File size in MB
            var fileType = file.type;
            var fileName = file.name;

            // Preview generation based on file type
            var preview = '';
            if (fileType.startsWith('image/')) {
                preview = `<img src="${URL.createObjectURL(file)}" alt="${fileName}">`;
            } else if (fileType === 'application/pdf') {
                preview = `<i class="fas fa-file-pdf" style="font-size: 40px; color: #d9534f;"></i>`;
            } else if (fileType === 'application/msword' || fileType === 'application/vnd.openxmlformats-officedocument.wordprocessingml.document') {
                preview = `<i class="fas fa-file-word" style="font-size: 40px; color: #007bff;"></i>`;
            } else if (fileType === 'application/vnd.ms-excel' || fileType === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet') {
                preview = `<i class="fas fa-file-excel" style="font-size: 40px; color: #28a745;"></i>`;
            } else if (fileType === 'application/zip') {
                preview = `<i class="fas fa-file-archive" style="font-size: 40px; color: #6c757d;"></i>`;
            } else {
                preview = `<i class="fas fa-file-alt" style="font-size: 40px; color: #007bff;"></i><p>Önizleme mevcut değil.</p>`;
            }

            // Add the preview to the UI
            filePreviews += `<div class="file-preview" data-file="${fileName}">
                                    ${preview}
                                    <div class="file-name">${fileName}</div>
                                    <div class="file-size">${fileSizeMB} MB</div>
                                    <button class="delete-btn" onclick="removeFilePreview(event)"><i class="fas fa-times"></i></button>
                                  </div>`;
        });

        $('#file-previews').html(filePreviews);
        $('#upload-btn').show(); // Show the upload button if files are added
    }

    // Function to remove file preview
    function removeFilePreview(event) {
        var filePreview = $(event.target).closest('.file-preview');
        filePreview.remove();
        if ($('#file-previews .file-preview').length === 0) {
            $('#upload-btn').hide(); // Hide upload button if no files left
        }
    }

    // Upload files when the upload button is clicked
    $('#upload-btn').on('click', function() {
        var formData = new FormData();
        $.each($('#file-input')[0].files, function(i, file) {
            formData.append('files[]', file);
        });

        // Show loading spinner
        $('#loading-spinner').show();
        $('#upload-response').html('');

        $.ajax({
            url: 'upload.php',  // PHP script to handle file uploads
            type: 'POST',
            data: formData,
            processData: false,
            contentType: false,
            success: function(response) {
                // Hide loading spinner after successful upload
                $('#loading-spinner').hide();

                // Show success message
                $('#upload-response').html('<div class="alert alert-success">Dosya yükleme başarılı!</div>');

                // Clear the file previews after successful upload
                setTimeout(function() {
                    $('#upload-response .alert').fadeOut();
                }, 3000);

                $('#file-previews').html('');
                $('#file-input').val('');
                $('#upload-btn').hide(); // Hide upload button after upload
            },
            error: function() {
                // Hide loading spinner if error occurs
                $('#loading-spinner').hide();

                // Show error message
                $('#upload-response').html('<div class="alert alert-danger">Dosya yüklerken hata oldu.</div>');
            }
        });
    });
</script>