<?php
// guvenlik kodlarini dahil et
require_once 'inc/guvenlik.php';

// Form verilerini işleme
$response = ['success' => false, 'message' => ''];

// AJAX isteğiyle gelen verileri al
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // CSRF token kontrolü
    if ($_POST['eposta'] !== $_SESSION['eposta']) {
        $response['message'] = 'Geçersiz istek.';
    } else {
        // component_id ve file_ids'yi kontrol et
        if (isset($_POST['component_id']) && is_numeric($_POST['component_id']) && isset($_POST['file_ids'])) {
            $componentId = (int)$_POST['component_id'];
            $fileIds = $_POST['file_ids']; // Bu array olmalıdır

            // Dosya ID'lerinin geçerli olduğunu doğrulayalım
            $fileIds = array_map('intval', $fileIds); // Dosya ID'lerini sayıya dönüştürerek güvenli hale getirelim

            // Dosya güncelleme işlemi yapılabilir...
            // Burada sadece örnek olarak devam ediyoruz
            // Örneğin, komponent ile dosyaları ilişkilendirme işlemi
            $fileIdsString = implode(',', $fileIds);  // Dosya ID'lerini virgülle birleştiriyoruz

            $sql_update = "UPDATE komponent SET dosyalar = :files WHERE id = :component_id";
            $stmt_update = $baglantim->prepare($sql_update);
            $stmt_update->execute([
                ':files' => $fileIdsString,
                ':component_id' => $componentId
            ]);

            $response['success'] = true;
            $response['message'] = 'Dosyalar başarıyla kaydedildi.';
        } else {
            $response['message'] = 'Eksik veya geçersiz veri.';
        }
    }
    echo json_encode($response);
    exit;
}

ob_end_flush();
?>



<style>


    /* Highlight selected items in the dropdown
    .dropdown-item.selected {
        background-color: #00796b;
        color: white;
    }
    */
     */

    /* Indicate the selected items in the input field */
    #searchInput::placeholder {
        color: #00796b;
        font-style: italic;
    }

        h2 {
            text-align: center;
            color: #00796b;
            font-size: 2.5rem;
            margin-bottom: 40px;
            font-weight: bold;
        }

        .form-label {
            font-size: 1.1rem;
            color: #00796b;
        }

        .form-select {
            border-radius: 10px;
            padding: 12px;
            border: 1px solid #00796b;
            transition: border-color 0.3s ease;
        }

        .form-select:focus {
            border-color: #004d40;
            box-shadow: 0 0 0 0.2rem rgba(0, 77, 64, 0.25);
        }

        .file-item {
            background-color: #ffffff;
            padding: 20px;
            margin-bottom: 20px;
            display: flex;
            align-items: center;
            flex-direction: column;
            border-radius: 15px;
            border: 1px solid #ccc;
            transition: all 0.3s ease;
            cursor: pointer;
            box-shadow: 0 4px 10px rgba(0, 0, 0, 0.05);
        }

        .file-item.selected {
            background-color: #004d40;
            color: #ffffff;
            border-color: #004d40;
            box-shadow: 0 4px 20px rgba(0, 77, 64, 0.2);
        }

        .file-preview {
            width: 120px;
            height: 120px;
            background-color: #f0f0f0;
            border-radius: 15px;
            display: flex;
            justify-content: center;
            align-items: center;
            margin-bottom: 15px;
        }

        .file-preview img {
            width: 100%;
            height: 100%;
            object-fit: contain;
        }

        .file-preview i {
            font-size: 60px;
            color: #00796b;
        }

        .file-item label {
            font-size: 1.1rem;
            color: #00796b;
            margin-top: 10px;
        }

        .btn-primary {
            background-color: #00796b;
            border-color: #00796b;
            padding: 12px 30px;
            width: 100%;
            border-radius: 10px;
            font-size: 1.2rem;
            font-weight: 500;
            transition: all 0.3s ease;
        }

        .btn-primary:hover {
            background-color: #004d40;
            border-color: #004d40;
        }

        .alert {
            margin-top: 20px;
            font-size: 1.1rem;
        }

        /* Grid layout */
        .file-items {
            display: grid;
            grid-template-columns: repeat(auto-fill, minmax(150px, 1fr));
            gap: 20px;
        }

        /* Select All Button */
        .select-all-btn {
            margin-bottom: 20px;
            font-size: 1.1rem;
            background-color: #00796b;
            color: white;
            border: none;
            padding: 10px 20px;
            border-radius: 10px;
            cursor: pointer;
        }

        .select-all-btn:hover {
            background-color: #004d40;
        }

        /* Dropdown Styles */
        .dropdown-menu {
            max-height: 250px;
            overflow-y: auto;
            width: 100%;
            padding: 10px;
        }

        .search-input {
            width: 100%;
            padding: 10px;
            margin-bottom: 15px;
            border-radius: 10px;
            border: 1px solid #00796b;
            font-size: 1rem;
        }

        .dropdown-item {
            padding: 10px;
            cursor: pointer;
            color: #00796b;
        }

        .dropdown-item:hover {
            background-color: #00796b;
            color: white;
        }

        .highlight {
            background-color: #ff0;
        }

    /* Visual indicator style */
    .selection-indicator {
        width: 15px;
        height: 15px;
        border-radius: 50%;
        background-color: #ccc; /* Default color */
        margin-right: 10px;
        display: inline-block;
    }

    .dropdown-item.selected .selection-indicator {
        background-color: #007bff; /* Active color (e.g., blue) */
    }

</style>

    <h2></h2>
<div id="selectedTags" class="mt-2">
    <!-- Seçilen etiketler burada görünecek -->
</div>

<!-- HTML Form Kodu -->
<form method="POST" id="updateForm">
    <!-- CSRF token input -->
    <input type="hidden" name="csrf_token" value="<?php echo $_SESSION['csrf_token']; ?>">

    <!-- Dropdown for component selection -->
    <div class="mb-4">
        <label for="component_id" class="form-label">Ürün Seç</label>
        <div class="dropdown">
            <input type="text" class="form-control search-input" id="searchInput" placeholder="Ürünleri arayın..." data-bs-toggle="dropdown">
            <ul class="dropdown-menu" id="dropdownMenu" aria-labelledby="searchInput">
                <li><a class="dropdown-item" href="#" data-id="">Bir Ürün Seç</a></li>
                <?php foreach ($components as $component): ?>
                    <li>
                        <a class="dropdown-item" href="#" data-id="<?php echo htmlspecialchars($component['id']); ?>">
                            <span class="selection-indicator"></span> <!-- Görsel seçim göstergesi -->
                            <?php echo htmlspecialchars($component['ad']); ?>
                        </a>
                    </li>
                <?php endforeach; ?>
            </ul>
        </div>
    </div>

    <!-- Select All / Deselect All Button -->
    <button type="button" class="select-all-btn" id="selectAll">Tümünü Seç</button>

    <!-- Dosya Seçim Alanı -->
    <div class="file-items" id="fileItems">
        <?php foreach ($files as $file): ?>
            <div class="file-item" data-file-id="<?php echo htmlspecialchars($file['id']); ?>">
                <div class="file-preview">
                    <?php
                    $extension = pathinfo($file['file_name'], PATHINFO_EXTENSION);
                    if (in_array($extension, ['jpg', 'jpeg', 'png', 'gif', 'webp'])): ?>
                        <img src="<?php echo htmlspecialchars($file['file_path']); ?>" alt="<?php echo htmlspecialchars($file['file_name']); ?>" />
                    <?php elseif ($extension === 'pdf'): ?>
                        <embed src="<?php echo htmlspecialchars($file['file_path']); ?>" type="application/pdf" width="100" height="100">
                    <?php else : ?>
                        <i class="fas fa-file-alt"></i>
                    <?php endif; ?>
                </div>
                <label><?php echo htmlspecialchars($file['file_name']); ?></label>
            </div>
        <?php endforeach; ?>
    </div>

    <!-- Gizli Komponent ID girişi -->
    <input type="hidden" name="component_id" id="component_id" value="">

    <!-- Gönder Butonu -->
    <button type="submit" class="btn btn-primary mt-4">Seçili Dosyaları Ürüne Kaydet</button>
</form>

<script>
    $(document).ready(function() {
        var debounceTimeout;

        // Handle component selection using a 'selected' class for visual indication
        $('#dropdownMenu').on('click', '.dropdown-item', function() {
            var componentId = $(this).data('id');
            var componentName = $(this).text().trim();

            // Toggle the 'selected' class and the visual indicator
            $(this).toggleClass('selected');
            $(this).find('.selection-indicator').toggleClass('active'); // Visual feedback for selection

            // Update the selected components list and tags
            updateSelectedComponents();

            // Sync the file previews with the selected components
            syncFilePreviews(componentId, $(this).hasClass('selected'));
        });

        // Update the hidden input field and tags with selected components
        function updateSelectedComponents() {
            var selectedComponents = [];
            $('#dropdownMenu').find('.dropdown-item.selected').each(function() {
                selectedComponents.push($(this).data('id'));
            });
            $('#component_id').val(selectedComponents.join(','));  // Store selected component IDs

            // Display selected components as tags
            updateTags(selectedComponents);
        }

        // Display selected components as tags
        function updateTags(selectedComponents) {
            var tagContainer = $('#selectedTags');
            tagContainer.empty();  // Clear previous tags

            selectedComponents.forEach(function(componentId) {
                var componentName = $('#dropdownMenu').find('[data-id="' + componentId + '"]').text().trim();
                var tag = $('<span class="badge bg-primary me-1 mb-1">').text(componentName);
                var removeBtn = $('<button class="btn-close btn-close-white ms-1" type="button"></button>');

                // Remove tag when close button is clicked
                removeBtn.on('click', function() {
                    $('#dropdownMenu').find('.dropdown-item[data-id="' + componentId + '"]').removeClass('selected');
                    tag.remove();
                    updateSelectedComponents();  // Update selected components list
                    syncFilePreviews(componentId, false); // Deselect related file previews
                });

                tag.append(removeBtn);
                tagContainer.append(tag);
            });
        }

        // Sync the selection of file previews based on the selected components
        function syncFilePreviews(componentId, isSelected) {
            // Fetch the related file items based on the selected component
            $.get('iliskilendir.php', { component_id: componentId }, function(response) {
                var selectedFileIds = response;  // Array of file IDs related to the selected component

                // Loop through each file item and update its selection state
                $('.file-item').each(function() {
                    var fileId = $(this).data('file-id');

                    // If the component is selected, select related file previews, otherwise deselect them
                    if (isSelected && selectedFileIds.includes(fileId.toString())) {
                        $(this).addClass('selected');
                    } else {
                        $(this).removeClass('selected');
                    }
                });
            });
        }

        // Filter dropdown options based on search input
        $('#searchInput').on('input', function() {
            clearTimeout(debounceTimeout);
            var searchText = $(this).val().toLowerCase();
            debounceTimeout = setTimeout(function() {
                $('#dropdownMenu').find('.dropdown-item').each(function() {
                    var itemText = $(this).text().toLowerCase();
                    $(this).toggle(itemText.includes(searchText));
                });
            }, 300);
        });

        // Open dropdown menu when input field is focused
        $('#searchInput').on('focus', function() {
            $('#dropdownMenu').show();  // Show the dropdown menu when the input field is focused
        });

        // Close dropdown menu if clicked outside
        $(document).on('click', function(event) {
            if (!$(event.target).closest('#searchInput').length && !$(event.target).closest('#dropdownMenu').length) {
                $('#dropdownMenu').hide();  // Hide the dropdown menu when clicked outside
            }
        });

        // Handle Select All / Deselect All button functionality
        $('#selectAll').on('click', function() {
            var buttonText = $(this).text().trim();

            // If the button text is "Select All", select all items
            $('.file-item').toggleClass('selected', buttonText === 'Tümünü Seç');
            updateSelectAllButton();
        });

        // Toggle selection when clicking on the file preview itself
        $('#fileItems').on('click', '.file-item', function() {
            $(this).toggleClass('selected');
            updateSelectAllButton();
        });

        // Function to update Select All button text based on the selection state
        function updateSelectAllButton() {
            var totalItems = $('.file-item').length;
            var selectedItems = $('.file-item.selected').length;

            if (totalItems === selectedItems) {
                $('#selectAll').text('Seçimleri Kaldır');
            } else {
                $('#selectAll').text('Tümünü Seç');
            }
        }

        $('#updateForm').on('submit', function(e) {
            e.preventDefault();

            // Seçilen ürünleri almak için tüm işaretlenen dropdown item'ları kontrol et
            var componentIds = [];
            $('.dropdown-item.selected').each(function() {
                componentIds.push($(this).data('id')); // Dropdown item'ların 'data-id' özelliğini al
            });

            // Eğer hiçbiri seçilmediyse, uyarı göster
            if (componentIds.length === 0) {
                alert('Please select at least one component!');
                return;
            }

            var selectedFileIds = [];
            $('.file-item.selected').each(function() {
                selectedFileIds.push($(this).data('file-id'));
            });

            $.post('iliskilendir.php', {
                component_ids: componentIds.join(','), // Çoklu component_id'yi virgülle ayırarak gönder
                file_ids: selectedFileIds     // Send selected file IDs
            }, function(response) {
                if (response.success) {
                    var successMessage = `
        <div class="alert alert-success alert-dismissible fade show" role="alert">
            <strong>Success!</strong> ${response.message}
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
    `;
                    $('#responseMessage').html(successMessage).fadeIn(300);

                    // Auto-hide the success message after 4 seconds
                    setTimeout(function() {
                        $('#responseMessage .alert').fadeOut(300);
                    }, 4000);

                    // Reset the selected items after the form is submitted
                    $('.dropdown-item').removeClass('selected'); // Deselect all dropdown items
                    $('.file-item').removeClass('selected');         // Remove selected class from file items
                    $('#selectAll').text('Tümünü Seç');               // Reset Select All button text

                    // Clear the tags (selected components) after form submission
                    $('#selectedTags').empty(); // Remove all tags

                    // Remove 'selected' class from dropdown items and reset the input field placeholder style
                    $('#searchInput').attr('placeholder', 'Search components...'); // Reset placeholder
                } else {
                    $('#responseMessage').html('<div class="alert alert-danger">' + response.message + '</div>');
                }
            }, 'json');
        });

    });

</script>