<?php
require_once 'inc/guvenlik.php';
$DuzenlemeID = $_GET['KategoriDuzenleID'];

// Kategori düzenle sayfasına giderken geçer

try {
    // Kategori verisini al
    $kd = $baglantim->prepare("SELECT * FROM kategori WHERE id = :id LIMIT 1");
    $kd->bindParam(':id', $DuzenlemeID, PDO::PARAM_INT);
    $kd->execute();
    $kds = $kd->fetch(PDO::FETCH_ASSOC);
    if (!$kds) {
        die("Kategori bulunamadı.");
    }
} catch (PDOException $e) {
    die("Veri çekilirken bir problem oluştu: " . $e->getMessage());
}

// Kategori ağacını al
try {
    $kategoriSQL = "WITH RECURSIVE cte AS (
        SELECT id, CAST(ad AS CHAR(200)) AS ad,
            CAST(ad AS CHAR(200)) AS yol,
            CAST(ad AS CHAR(200)) AS path,
            CAST(kategori_id AS CHAR(200)) AS katID,
            0 as derinlik
        FROM kategori WHERE kategori_id = 0
        UNION ALL
        SELECT c.id, CONCAT(REPEAT(' - ', cte.derinlik + 1), c.ad),
            CONCAT(cte.path, ' > ', c.ad),
            CONCAT(cte.yol, ',', c.ad),
            CONCAT(cte.id),
            cte.derinlik + 1
        FROM kategori c JOIN cte ON cte.id = c.kategori_id
    )
    SELECT * FROM cte ORDER BY path";

    $kategori_sonuc = $baglantim->query($kategoriSQL);
    $kategori_sonuc->setFetchMode(PDO::FETCH_ASSOC);
} catch (PDOException $e) {
    die("Kategori ağacı verisi çekilirken bir hata oluştu: " . $e->getMessage());
}
?>

<h5>Kategori Düzenle</h5>
<form id="kategori_duzenle" class="row g-3" action="kategori-duzenleDB.php" method="post">
    <div id="ad_2" class="col-md-6 form-select-sm">
        <label for="ad22" class="form-label">Yeni Ad</label>
        <input type="text" name="ad22" value="<?= htmlspecialchars($kds['ad'], ENT_QUOTES) ?>" class="form-control form-select-sm input_ad2" id="ad22" required>
    </div>

    <input id="KategoriDuzenleID" type="hidden" name="KategoriDuzenleID" value="<?= $DuzenlemeID ?>">

    <div id="kategori_2" class="col-md-6 form-select-sm">
        <label for="kategori2" class="form-label">Kategori Ağacındaki Konumu</label>
        <select name="kategori2" id="kategori2" class="form-select form-select-sm" size="20" required>
            <?php
            $id = explode(',', $DuzenlemeID)[0]; // set edilecek id
            while ($kategori_satir = $kategori_sonuc->fetch()) {
                $isaretle = ($id == $kategori_satir['id']) ? "selected" : '';
                $devredisi = ($id == $kategori_satir['id']) ? '' : "disabled";
                $kategori_ad = str_replace(' - ', '', $kategori_satir['ad']); // Gereksiz çizgilerden arındır
                ?>
                <option value="<?= $kategori_satir['id'] . ',' . $kategori_satir['yol'] ?>" <?= $isaretle . ' ' . $devredisi ?>>
                    <?= htmlspecialchars($kategori_ad, ENT_QUOTES) ?>
                </option>
            <?php } ?>
        </select>
    </div>

    <div class="col-6 text-first">
        <span id="DuzenleMesaji"></span>
    </div>

    <div class="col-6 text-end">
        <button type="submit" class="btn btn-primary btn-sm">Kaydet</button>
    </div>
</form>
