<?php
require_once 'inc/guvenlik.php';
?>
<h5>Kategori Listesi</h5>
<table id="tablom" class="display nowrap" style="width:100%">

    <thead>
    <tr>
        <th></th>
    </tr>
    </thead>


    <tbody>
    <?php
    $liste = $baglantim->prepare("WITH RECURSIVE cte AS
(
  SELECT id, CAST(ad AS CHAR(200)) AS ad,
         CAST(ad AS CHAR(200)) AS yol,
         CAST(ad AS CHAR(200)) AS path,
    	 CAST(kategori_id AS CHAR(200)) AS katID,
         0 as derinlik
  FROM kategori WHERE kategori_id = 0
  UNION ALL
  SELECT c.id,
         CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
         CONCAT(cte.path, ' > ', c.ad),
         CONCAT(cte.yol, ' > ', c.ad),
         CONCAT(cte.id),
         cte.derinlik+1
  FROM kategori c JOIN cte ON
  cte.id=c.kategori_id
)
SELECT * FROM cte ORDER BY path;");

    $liste->execute();
    $sonuc = $liste->fetchAll();

    foreach ($sonuc as $satir) {
        ?>
        <tr>
            <!-- Verileri güvenli bir şekilde yazdırmak için htmlspecialchars kullanıyoruz -->
            <td><?php echo htmlspecialchars($satir['id'], ENT_QUOTES, 'UTF-8') . ',' . htmlspecialchars($satir['katID'], ENT_QUOTES, 'UTF-8'); ?></td>
            <td></td>
            <td><?php echo htmlspecialchars($satir['ad'], ENT_QUOTES, 'UTF-8'); ?></td>
        </tr>
    <?php } ?>


    </tbody>

    <tfoot>
    <tr>
        <th></th>
        <th></th>
        <th></th>
        <th></th>
    </tr>
    </tfoot>
</table>

<script>
    $(document).ready(function () {

        var benimTablom = $('#tablom').DataTable({
            responsive: true,
            AutoWidth: false,
            searchHighlight: true,
            "pageLength": 10, // varsayilan olacak gosterilecek kayit
            columns: [
                {title: "Id", "data": "iD", defaultContent: '', "visible": false},
                {title: "No", "data": "no", "width": "1%"},
                {title: "Kategori", "data": "kategori", "width": "100%"},
                {title: "İşlemler", "data": "iD", "width": "1%"},


            ],
            columnDefs: [
                {
                    searchable: false,
                    orderable: false,
                    targets: 1
                },
                {targets: [0, 1], searchable: false}, // arama yapilmamasini istedigimiz kolanlar
                {"bSortable": false, "aTargets": [0, 1, 2, 3]}, // siralama olmamasini istedigimiz hucre 1, 3, 5 vs gibi
                {"targets": 0, "data": 'iD'},
                {"targets": 1, "data": 'no'},
                {"targets": 2, "data": 'kategori'},


                {
                    "targets": [3],
                    "data": 'iD',
                    "render": function (data) {
                        return '<div class="btn-group"><a href="index.php?sayfa=KategoriDuzenle&KategoriDuzenleID=' + data + '"> <button class="btn btn-sm btn-primary mx-1 duzenleBTN" id=' + data + '><i class="fa fa-pencil"></i></button></a> <button class="btn btn-sm btn-danger mx-1 KatsilBTN" id=' + data + '><i class="fa fa-trash-can"></button></div>'
                    },
                },

                //aramada vurgulanmasını ıstemedıgımız kolonu secelım.
                {
                    targets: [0, 1],
                    className: 'search-hilite',
                },
                //aramada vurgulanmasını ıstemedıgımız kolonu secelım.

            ],
            order: [[0, '']],
            language: {
                sInfoEmpty: '',
                info: 'Sayfa : _PAGE_ / _PAGES_',
                infoEmpty: 'Kayit bulunamadi',
                infoFiltered: '(_MAX_ kayıt icinden arandi)',
                lengthMenu: '_MENU_ &nbsp;&nbsp;kayıt göster',
                zeroRecords: 'Aramada kayit bulunamadi',
                sSearch: 'Ara:',
                sEmptyTable: 'Veritabaninda kayit bulunamadi',
            },
        });

        //aramada vurgulanmasını ıstemedıgımız kolonu secelım.
        benimTablom.on('draw', function () {
            var body = $('.search-hilite', benimTablom.table().body());

            body.unhighlight();
            // body.highlight(benimTablom.search());
        });
        //aramada vurgulanmasını ıstemedıgımız kolonu secelım.


        buildSelect(benimTablom);
        benimTablom.on('draw', function () {
            buildSelect(benimTablom);
        });

        // no tablo sutununa sıra no eklesın
        benimTablom.on('order.dt search.dt', function () {
            let i = 1;

            benimTablom.cells(null, 1, {search: 'applied', order: 'applied'}).every(function (cell) {
                this.data(i++);
            });
        }).draw();
        // no tablo sutununa sıra no eklesın

    });

    function buildSelect(benimTablom) {
        benimTablom.columns([]).every(function () { // benimTablom.columns([2, 3]).every(function () { bu satir boyle olursa 2 ve 3. sutunlarin altinda acilir menu ile filtreleme yapar
            var column = benimTablom.column(this, {search: 'applied'});
            var select = $('<select><option value=""></option></select>')
                .appendTo($(column.footer()).empty())
                .on('change', function () {
                    var val = $.fn.dataTable.util.escapeRegex(
                        $(this).val()
                    );

                    column
                        .search(val ? '^' + val + '$' : '', true, false)
                        .draw();
                });

            column.data().unique().sort().each(function (d, j) {
                select.append('<option value="' + d + '">' + d + '</option>');
            });

            // The rebuild will clear the exisiting select, so it needs to be repopulated
            var currSearch = column.search();
            console.log(currSearch)
            if (currSearch) {
                var unescaped = currSearch.replace(/\\/g, '');
                console.log(unescaped)
                select.val(unescaped.substring(1, unescaped.length - 1));
            }
        });


    }

</script>