<?php
require_once 'inc/guvenlik.php';

// Detay ID'si al
$detayID = $_GET['KomponentDetayID'];

// SQL sorgusu
$liste = $baglantim->prepare("WITH RECURSIVE cte_lokasyon AS (
    SELECT l.id AS lokasyon_id, 
           COALESCE(NULLIF(l.ad, ''), '---') AS lokasyon_ad, 
           l.lokasyon_id AS lokasyon_lokasyon_id, 
           0 AS derinlik,
           COALESCE(NULLIF(l.ad, ''), '---') AS tam_lokasyon
    FROM lokasyon l
    WHERE l.lokasyon_id = 0  

    UNION ALL

    SELECT l.id AS lokasyon_id, 
           COALESCE(NULLIF(l.ad, ''), '---') AS lokasyon_ad, 
           l.lokasyon_id AS lokasyon_lokasyon_id, 
           cte_lokasyon.derinlik + 1 AS derinlik,
           CONCAT(cte_lokasyon.tam_lokasyon, ' > ', COALESCE(NULLIF(l.ad, ''), '---')) AS tam_lokasyon
    FROM lokasyon l
    JOIN cte_lokasyon ON cte_lokasyon.lokasyon_id = l.lokasyon_id  
),
cte_kategori AS (
    SELECT k.id AS kategori_id, 
           COALESCE(NULLIF(k.ad, ''), '---') AS kategori_ad, 
           k.kategori_id AS kategori_kategori_id, 
           0 AS derinlik,
           COALESCE(NULLIF(k.ad, ''), '---') AS tam_kategori
    FROM kategori k
    WHERE k.kategori_id = 0  

    UNION ALL

    SELECT k.id AS kategori_id, 
           COALESCE(NULLIF(k.ad, ''), '---') AS kategori_ad, 
           k.kategori_id AS kategori_kategori_id, 
           cte_kategori.derinlik + 1 AS derinlik,
           CONCAT(cte_kategori.tam_kategori, ' > ', COALESCE(NULLIF(k.ad, ''), '---')) AS tam_kategori
    FROM kategori k
    JOIN cte_kategori ON cte_kategori.kategori_id = k.kategori_id  
),
cte_paket AS (
    SELECT p.id AS paket_id, 
           COALESCE(NULLIF(p.ad, ''), '---') AS paket_ad, 
           p.paket_id AS paket_paket_id, 
           0 AS derinlik,
           COALESCE(NULLIF(p.ad, ''), '---') AS tam_paket
    FROM paket p
    WHERE p.paket_id = 0  

    UNION ALL

    SELECT p.id AS paket_id, 
           COALESCE(NULLIF(p.ad, ''), '---') AS paket_ad, 
           p.paket_id AS paket_paket_id, 
           cte_paket.derinlik + 1 AS derinlik,
           CONCAT(cte_paket.tam_paket, ' > ', COALESCE(NULLIF(p.ad, ''), '---')) AS tam_paket
    FROM paket p
    JOIN cte_paket ON cte_paket.paket_id = p.paket_id  
)
SELECT 
    COALESCE(NULLIF(cte_lokasyon.lokasyon_id, ''), '---') AS lokasyon_id,
    COALESCE(NULLIF(cte_lokasyon.lokasyon_ad, ''), '---') AS lokasyon_ad,
    COALESCE(NULLIF(cte_lokasyon.tam_lokasyon, ''), '---') AS tam_lokasyon,
    COALESCE(NULLIF(cte_kategori.kategori_id, ''), '---') AS kategori_id,
    COALESCE(NULLIF(cte_kategori.kategori_ad, ''), '---') AS kategori_ad,
    COALESCE(NULLIF(cte_kategori.tam_kategori, ''), '---') AS tam_kategori,
    COALESCE(NULLIF(cte_paket.paket_id, ''), '---') AS paket_id,
    COALESCE(NULLIF(cte_paket.paket_ad, ''), '---') AS paket_ad,
    COALESCE(NULLIF(cte_paket.tam_paket, ''), '---') AS tam_paket,
    COALESCE(NULLIF(komp.id, ''), '---') AS komponent_id,
    COALESCE(NULLIF(komp.ad, ''), '---') AS komponent_ad,
    COALESCE(NULLIF(komp.ek_bilgi, ''), '---') AS ek_bilgi,
    COALESCE(NULLIF(komp.adet, ''), '---') AS adet,
    COALESCE(NULLIF(komp.dosyalar, ''), '---') AS dosyalar,
    COALESCE(NULLIF(komp.detaylar, ''), '---') AS detaylar,
    COALESCE(NULLIF(uretici.id, ''), '---') AS uretici_id,
    COALESCE(NULLIF(uretici.ad, ''), '---') AS uretici_ad,
    COALESCE(NULLIF(tedarikci.id, ''), '---') AS tedarikci_id,
    COALESCE(NULLIF(tedarikci.ad, ''), '---') AS tedarikci_ad
FROM komponent komp
LEFT JOIN cte_lokasyon ON cte_lokasyon.lokasyon_id = komp.lokasyon_id
LEFT JOIN cte_kategori ON cte_kategori.kategori_id = komp.kategori_id
LEFT JOIN cte_paket ON cte_paket.paket_id = komp.paket_id
LEFT JOIN uretici ON uretici.id = komp.uretici_id
LEFT JOIN tedarikci ON tedarikci.id = komp.tedarikci_id
WHERE komp.id = :detayID
ORDER BY komp.id DESC");

$liste->bindParam(':detayID', $detayID, PDO::PARAM_INT);
$liste->execute();
$sonuc = $liste->fetch(PDO::FETCH_ASSOC);  // Fetch the result

if ($sonuc !== false) {
    // XSS koruması eklemek için htmlspecialchars kullanıldı
    $ad = htmlspecialchars(html_entity_decode($sonuc['komponent_ad']), ENT_QUOTES, 'UTF-8');
    $ek_bilgi = htmlspecialchars(html_entity_decode($sonuc['ek_bilgi']), ENT_QUOTES, 'UTF-8');
    $kategori1 = htmlspecialchars(html_entity_decode($sonuc['tam_kategori']), ENT_QUOTES, 'UTF-8');
    $uretici1 = htmlspecialchars(html_entity_decode($sonuc['uretici_ad']), ENT_QUOTES, 'UTF-8');
    $tedarikci1 = htmlspecialchars(html_entity_decode($sonuc['tedarikci_ad']), ENT_QUOTES, 'UTF-8');
    $lokasyon1 = htmlspecialchars(html_entity_decode($sonuc['tam_lokasyon']), ENT_QUOTES, 'UTF-8');
    $adet1 = htmlspecialchars(html_entity_decode($sonuc['adet']), ENT_QUOTES, 'UTF-8');
    $detaylar = html_entity_decode($sonuc['detaylar'], ENT_QUOTES, 'UTF-8');
    $dosyalar = htmlspecialchars(html_entity_decode($sonuc['dosyalar']), ENT_QUOTES, 'UTF-8');

    // Dosya ID'lerini ayrıştır
    $dosya_ids = explode(',', $dosyalar);
    $dosya_ids = array_map('trim', $dosya_ids); // Boşlukları temizle

    // Eğer dosya ID'leri varsa, uploads tablosundan dosya yollarını al
    if (!empty($dosya_ids)) {
        // Uploads tablosunda eşleşen dosya yollarını al
        $placeholders = implode(',', array_fill(0, count($dosya_ids), '?'));
        $sql_files = "SELECT file_path FROM uploads WHERE id IN ($placeholders)";
        $stmt_files = $baglantim->prepare($sql_files);
        $stmt_files->execute($dosya_ids);

        // Dosya yollarını al
        $file_paths = $stmt_files->fetchAll(PDO::FETCH_COLUMN);
    } else {
        $file_paths = [];
    }
} else {
    // Kayıt bulunamadığında hata mesajı
    echo "No record found!";
}
?>

<div style="margin-top:40px;">
    <h5>Ürün Detay</h5>
    <div class="card">
        <div class="card-header">
            <?php echo htmlspecialchars($ad, ENT_QUOTES, 'UTF-8') . ' > ' . htmlspecialchars($ek_bilgi, ENT_QUOTES, 'UTF-8'); ?>
        </div>
        <div class="card-body">

            <ul class="nav nav-tabs" id="myTab" role="tablist">
                <li class="nav-item" role="presentation">
                    <button class="nav-link active" id="home-tab" data-bs-toggle="tab"
                            data-bs-target="#home-tab-pane" type="button" role="tab" aria-controls="home-tab-pane"
                            aria-selected="true">Bilgiler
                    </button>
                </li>
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="profile-tab" data-bs-toggle="tab"
                            data-bs-target="#profile-tab-pane" type="button" role="tab"
                            aria-controls="profile-tab-pane" aria-selected="false">Ürün Özellikleri
                    </button>
                </li>
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="contact-tab" data-bs-toggle="tab"
                            data-bs-target="#contact-tab-pane" type="button" role="tab"
                            aria-controls="contact-tab-pane" aria-selected="false">Data Sheet
                    </button>
                </li>
            </ul>
            <div class="tab-content" id="myTabContent">

                <div class="tab-pane fade show active" id="home-tab-pane" role="tabpanel" aria-labelledby="home-tab"
                     tabindex="0">
                    <ul class="list-group">
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Ürün Adı:</div>
                                <?php echo $ad; ?>
                            </div>
                        </li>
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Tam Ürün Adı:</div>
                                <?php echo $ek_bilgi; ?>
                            </div>
                        </li>
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Kategori:</div>
                                <?php echo $kategori1; ?>
                            </div>
                        </li>
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Üretici:</div>
                                <?php echo $uretici1; ?>
                            </div>
                        </li>
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Tedarikçi:</div>
                                <?php echo $tedarikci1; ?>
                            </div>
                        </li>
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Lokasyon:</div>
                                <?php echo $lokasyon1; ?>
                            </div>
                        </li>
                        <li class="list-group-item d-flex justify-content-between align-items-start">
                            <div class="ms-2 me-auto">
                                <div class="fw-bold">Adet:</div>
                                <?php echo $adet1; ?>
                            </div>
                        </li>
                    </ul>
                </div>

                <div class="tab-pane fade" id="profile-tab-pane" role="tabpanel" aria-labelledby="profile-tab"
                     tabindex="0"><?php echo $detaylar;?></div>
                <div class="tab-pane fade" id="contact-tab-pane" role="tabpanel" aria-labelledby="contact-tab"
                     tabindex="0">
                    <?php
                    // Show the first file path if available
                    if (!empty($file_paths)) {
                        echo '<embed class="pdf" src="' . $file_paths[0] . '" width="100%" height="1000">';
                    } else {
                        echo "No Data Sheet available.";
                    }
                    ?>
                </div>
            </div>
        </div>
    </div>
</div>
