<?php
require_once 'inc/guvenlik.php';

$DuzenlemeID = filter_input(INPUT_GET, 'KomponentDuzenleID', FILTER_SANITIZE_NUMBER_INT);

// SQL Enjeksiyonuna karşı önlem: Prepared Statements kullanıyoruz.
$kd = $baglantim->prepare("SELECT * FROM komponent WHERE id = :DuzenlemeID");
$kd->bindParam(':DuzenlemeID', $DuzenlemeID, PDO::PARAM_INT);
$kd->execute();
$kds = $kd->fetch();
?>
<h5>Ürün Düzenle</h5>
<form id="KomponentDuzenlemeFormu" class="row g-0 mb-5" method="post">
    <div id="ad_2" class="col-md-6 form-select-sm">
        <label for="ad22" class="form-label">Ürün Adı</label>
        <input type="text" name="ad22" value="<?php echo htmlspecialchars($kds['ad'], ENT_QUOTES, 'UTF-8'); ?>"
               class="form-control form-select-sm input_ad2" id="ad22" autofocus>
    </div>

    <input id="KomponentDuzenleID" type="hidden" name="KomponentDuzenleID" value="<?php echo htmlspecialchars($DuzenlemeID, ENT_QUOTES, 'UTF-8'); ?>">

    <div id="ek_bilgi_2" class="col-md-4 form-select-sm">
        <label for="ek_bilgi2" class="form-label">Ek Bilgi</label>
        <input type="text" name="ek_bilgi2" value="<?php echo htmlspecialchars($kds['ek_bilgi'], ENT_QUOTES, 'UTF-8'); ?>"
               class="form-control form-select-sm" id="ek_bilgi2">
    </div>

    <div id="adet_2" class="col-md-2 form-select-sm">
        <label for="adet2" class="form-label">Adet</label>
        <input type="number" name="adet2" value="<?php echo htmlspecialchars($kds['adet'], ENT_QUOTES, 'UTF-8'); ?>"
               class="form-control form-select-sm" id="adet2">
    </div>

    <!-- KATEGORİ ÇEKME BÖLÜMÜ -->
    <div id="kategori_2" class="col-md-4 form-select-sm">
        <label for="kategori2" class="form-label">Kategori</label>
        <?php
        try {
            $kategori = "WITH RECURSIVE cte AS
            (
                SELECT id, CAST(ad AS CHAR(200)) AS ad,
                       CAST(ad AS CHAR(200)) AS yol,
                       CAST(ad AS CHAR(200)) AS path,
                       0 as derinlik
                FROM kategori WHERE kategori_id = 0
                UNION ALL
                SELECT c.id,
                       CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
                       CONCAT(cte.path, ' > ', c.ad),
                       CONCAT(cte.yol, ' > ', c.ad),
                       cte.derinlik+1
                FROM kategori c JOIN cte ON
                cte.id=c.kategori_id
            )
            SELECT * FROM cte ORDER BY path;";
            $kategori_sonuc = $baglantim->query($kategori);
            $kategori_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="kategori2" id="kategori2" class="form-select form-select-sm" size="10">';

        while ($kategori_satir = $kategori_sonuc->fetch()) {
            $silinecek_cizgi = htmlspecialchars($kategori_satir['ad'], ENT_QUOTES, 'UTF-8'); // htmlspecialchars kullanarak XSS engellenir.
            ?>
            <option value="<?= htmlspecialchars($kategori_satir['id'] . ',' . $kategori_satir['yol'], ENT_QUOTES, 'UTF-8') ?>"
                <?= $kds['kategori_id'] == $kategori_satir['id'] ? 'selected="selected"' : ''; ?>>
                <?= $silinecek_cizgi ?>
            </option>
        <?php }
        echo '</select>';
        ?>
    </div>
    <!-- KATEGORİ ÇEKME BÖLÜMÜ -->

    <!-- PAKET ÇEKME BÖLÜMÜ -->
    <div id="paket_2" class="col-md-4 form-select-sm">
        <label for="paket2" class="form-label">Paket</label>
        <?php
        try {
            $paket = "WITH RECURSIVE cte AS
            (
                SELECT id, CAST(ad AS CHAR(200)) AS ad,
                       CAST(ad AS CHAR(200)) AS yol,
                       CAST(ad AS CHAR(200)) AS path,
                       0 as derinlik
                FROM paket WHERE paket_id = 0
                UNION ALL
                SELECT c.id,
                       CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
                       CONCAT(cte.path, ' > ', c.ad),
                       CONCAT(cte.yol, ' > ', c.ad),
                       cte.derinlik+1
                FROM paket c JOIN cte ON
                cte.id=c.paket_id
            )
            SELECT * FROM cte ORDER BY path;";
            $paket_sonuc = $baglantim->query($paket);
            $paket_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="paket2" id="paket2" class="form-select form-select-sm" size="10">';
        while ($paket_satir = $paket_sonuc->fetch()) {
            $silinecek_cizgi = htmlspecialchars($paket_satir['ad'], ENT_QUOTES, 'UTF-8');
            ?>
            <option value="<?= htmlspecialchars($paket_satir['id'] . ',' . $paket_satir['yol'], ENT_QUOTES, 'UTF-8') ?>"
                <?= $kds['paket_id'] == $paket_satir['id'] ? 'selected="selected"' : ''; ?>>
                <?= $silinecek_cizgi ?>
            </option>
        <?php }
        echo '</select>';
        ?>
    </div>
    <!-- PAKET ÇEKME BÖLÜMÜ -->

    <!-- ÜRETİCİ ÇEKME BÖLÜMÜ -->
    <div id="uretici_2" class="col-md-4 form-select-sm">
        <label for="uretici2" class="form-label">Üretici</label>
        <?php
        try {
            $uretici = "SELECT id, ad FROM uretici ORDER BY ad ASC";
            $uretici_sonuc = $baglantim->query($uretici);
            $uretici_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }
        echo '<select name="uretici2" id="uretici2" class="form-select form-select-sm" size="10">';

        while ($uretici_satir = $uretici_sonuc->fetch()) {
            $silinecek_cizgi = htmlspecialchars($uretici_satir['ad'], ENT_QUOTES, 'UTF-8');
            ?>
            <option value="<?= htmlspecialchars($uretici_satir['id'] . ',' . $uretici_satir['ad'], ENT_QUOTES, 'UTF-8') ?>"
                <?= $kds['uretici_id'] == $uretici_satir['id'] ? 'selected="selected"' : ''; ?>>
                <?= $silinecek_cizgi ?>
            </option>
        <?php }
        echo '</select>';
        ?>
    </div>
    <!-- ÜRETİCİ ÇEKME BÖLÜMÜ -->

    <!-- TEDARİKÇİ ÇEKME BÖLÜMÜ -->
    <div id="tedarikci_2" class="col-md-4 form-select-sm">
        <label for="tedarikci2" class="form-label">Tedarikçi</label>
        <?php
        try {
            $tedarikci = "SELECT id, ad FROM tedarikci ORDER BY ad ASC";
            $tedarikci_sonuc = $baglantim->query($tedarikci);
            $tedarikci_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }
        echo '<select name="tedarikci2" id="tedarikci2" class="form-select form-select-sm" size="10">';

        while ($tedarikci_satir = $tedarikci_sonuc->fetch()) {
            ?>
            <option value="<?= htmlspecialchars($tedarikci_satir['id'] . ',' . $tedarikci_satir['ad'], ENT_QUOTES, 'UTF-8') ?>"
                <?= $kds['tedarikci_id'] == $tedarikci_satir['id'] ? 'selected="selected"' : ''; ?>>
                <?= htmlspecialchars($tedarikci_satir['ad'], ENT_QUOTES, 'UTF-8') ?>
            </option>
        <?php }
        echo '</select>';
        ?>
    </div>
    <!-- TEDARİKÇİ ÇEKME BÖLÜMÜ -->

    <!-- LOKASYON ÇEKME BÖLÜMÜ -->
    <div id="lokasyon_2" class="col-md-4 form-select-sm">
        <label for="lokasyon2" class="form-label">Lokasyon</label>
        <?php
        try {
            $lokasyon = "WITH RECURSIVE cte AS
            (
                SELECT id, CAST(ad AS CHAR(200)) AS ad,
                       CAST(ad AS CHAR(200)) AS yol,
                       CAST(ad AS CHAR(200)) AS path,
                       0 as derinlik
                FROM lokasyon WHERE lokasyon_id = 0
                UNION ALL
                SELECT c.id,
                       CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
                       CONCAT(cte.path, ' > ', c.ad),
                       CONCAT(cte.yol, ' > ', c.ad),
                       cte.derinlik+1
                FROM lokasyon c JOIN cte ON
                cte.id=c.lokasyon_id
            )
            SELECT * FROM cte ORDER BY path;";
            $lokasyon_sonuc = $baglantim->query($lokasyon);
            $lokasyon_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="lokasyon2" id="lokasyon2" class="form-select form-select-sm" size="10">';

        while ($lokasyon_satir = $lokasyon_sonuc->fetch()) {
            $silinecek_cizgi = htmlspecialchars($lokasyon_satir['ad'], ENT_QUOTES, 'UTF-8');
            ?>
            <option value="<?= htmlspecialchars($lokasyon_satir['id'] . ',' . $lokasyon_satir['yol'], ENT_QUOTES, 'UTF-8') ?>" <?= $kds['lokasyon_id'] == $lokasyon_satir['id'] ? 'selected="selected"' : ''; ?>><?= $silinecek_cizgi ?></option>
        <?php }
        echo '</select>';
        ?>
    </div>
    <!-- LOKASYON ÇEKME BÖLÜMÜ -->

    <div id="tags1" class="col-md-4 form-select-sm">
        <label for="ek_bilgi" class="form-label">Tags</label>
        <input type="text" name="tags" class="form-control form-select-sm" id="tags">
    </div>


    <div id="detaylar1" class="">
        <label for="detaylar" class="">Detaylar</label>
        <textarea class="form-control" name="detaylar" placeholder="Detaylari giriniz" id="detaylar"><?= htmlspecialchars(html_entity_decode($kds['detaylar'], ENT_QUOTES | ENT_HTML5, 'UTF-8'), ENT_QUOTES, 'UTF-8'); ?></textarea>
    </div>

    <div class="form-group text-center mt-3">
        <button type="submit" class="btn btn-primary">Kaydet</button>
    </div>
</form>
<script>
    $("#KomponentDuzenlemeFormu").on("submit", function(e) {
        e.preventDefault(); // Formun sayfa yenilemesini engelle

        $.ajax({
            type: "POST",
            url: "komponent-duzenle-modalDB.php",
            data: new FormData(this),
            processData: false,
            contentType: false,
            success: function(response) {
                console.log('PHP Yanıtı:', response); // PHP yanıtını kontrol et
                var data = JSON.parse(response);

                // Başarı durumunu kontrol et
                if (data.success) {
                    $('#responseMessage').removeClass('alert-danger').addClass('alert-success');
                    $('#responseMessage').text(data.message).show(); // Başarı mesajını göster

                    // Başarı mesajını 5 saniye sonra gizle
                    setTimeout(function() {
                        $('#responseMessage').fadeOut(); // Mesajı yavaşça gizle
                    }, 5000); // 5000ms = 5 saniye

                    var updatedValues = data.updated_values;
                    var komponentRow = $('tr[data-komponent-id="' + data.komponent_id + '"]');

                    var kategoriId = updatedValues.kategori_id.split(',')[0].trim();
                    var paketId = updatedValues.paket_id.split(',')[0].trim();
                    var lokasyonId = updatedValues.lokasyon_id.split(',')[0].trim();
                    var ureticiId = updatedValues.uretici_id.split(',')[0].trim();
                    var tedarikciId = updatedValues.tedarikci_id.split(',')[0].trim();

                    // Kategoriyi ve diğer bilgileri güncelle
                    komponentRow.find('.komponent-ad-text').text(updatedValues.komponent_ad);
                    komponentRow.find('.komponent-ad-input').val(updatedValues.komponent_ad);
                    komponentRow.find('.ek-bilgi-text').text(updatedValues.ek_bilgi);
                    komponentRow.find('.alt-kategori-text').text(updatedValues.tam_kategori);
                    komponentRow.find('.paket-text').text(updatedValues.tam_paket);
                    komponentRow.find('.lokasyon-text').text(updatedValues.tam_lokasyon);
                    komponentRow.find('.uretici-text').text(updatedValues.uretici_ad);
                    komponentRow.find('.tedarikci-text').text(updatedValues.tedarikci_ad);

                    var tamKategori = updatedValues.tam_kategori;
                    var ilkKisim = tamKategori.includes('>') ? tamKategori.split('>')[0].trim() : tamKategori;
                    komponentRow.find('.kategori-text').text(ilkKisim); // HATA DÜZELTİLDİ ✅

                    // Kategori select elementini güncelle
                    komponentRow.find('.alt-kategori-select').each(function() {
                        var selectElement = $(this);
                        selectElement.find('option').each(function() {
                            if ($(this).val() == kategoriId) {
                                $(this).prop('selected', true);
                            }
                        });
                    });

                    // Paket select elementini güncelle
                    komponentRow.find('.paket-select').each(function() {
                        var selectElement = $(this);
                        selectElement.find('option').each(function() {
                            if ($(this).val() == paketId) {
                                $(this).prop('selected', true);
                            }
                        });
                    });

                    // Lokasyon select elementini güncelle
                    komponentRow.find('.lokasyon-select').each(function() {
                        var selectElement = $(this);
                        selectElement.find('option').each(function() {
                            if ($(this).val() == lokasyonId) {
                                $(this).prop('selected', true);
                            }
                        });
                    });

                    // Üretici select elementini güncelle
                    komponentRow.find('.uretici-select').each(function() {
                        var selectElement = $(this);
                        selectElement.find('option').each(function() {
                            if ($(this).val() == ureticiId) {
                                $(this).prop('selected', true);
                            }
                        });
                    });

                    // Tedarikçi select elementini güncelle
                    komponentRow.find('.tedarikci-select').each(function() {
                        var selectElement = $(this);
                        selectElement.find('option').each(function() {
                            if ($(this).val() == tedarikciId) {
                                $(this).prop('selected', true);
                            }
                        });
                    });



                    var komponentId = data.komponent_id;  // PHP yanıtındaki komponent_id
                    var yeniKomponentAd = data.updated_values.komponent_ad;  // Yeni komponent adı
                    var yeniEkBilgi = data.updated_values.ek_bilgi;  // Yeni ek bilgi

// "komponent_ad" select öğesini güncelle
                    $('select[name="komponent_adSelect"]').each(function() {
                        var selectElement = $(this);

                        // Tüm option öğelerini güncelle
                        selectElement.find('option').each(function() {
                            var optionValue = $(this).val();  // option'ın value değerini al
                            if (optionValue == komponentId) {
                                $(this).text(yeniKomponentAd);  // Option öğesinin metnini güncelle
                            }
                        });
                    });

// "ek_bilgi" select öğesini güncelle
                    $('select[name="ek_bilgiSelect"]').each(function() {
                        var selectElement = $(this);

                        // Tüm option öğelerini güncelle
                        selectElement.find('option').each(function() {
                            var optionValue = $(this).val();  // option'ın value değerini al
                            if (optionValue == komponentId) {
                                $(this).text(yeniEkBilgi);  // Option öğesinin metnini güncelle
                            }
                        });
                    });

// KomponentRow ile ilgili bilgiyi de kontrol edelim
                    console.log("Yeni Komponent Adı: ", yeniKomponentAd);
                    console.log("Yeni Ek Bilgi: ", yeniEkBilgi);







                    $("#KomponentDuzenlemeFormu").on("submit", function(e) {
                        e.preventDefault(); // Formun sayfa yenilemesini engelle

                        $.ajax({
                            type: "POST",
                            url: "komponent-duzenle-modalDB.php",
                            data: new FormData(this),
                            processData: false,
                            contentType: false,
                            success: function(response) {
                                console.log('PHP Yanıtı:', response); // PHP yanıtını kontrol et
                                var data = JSON.parse(response);

                                // Başarı durumunu kontrol et
                                if (data.success) {
                                    $('#responseMessage').removeClass('alert-danger').addClass('alert-success');
                                    $('#responseMessage').text(data.message).show(); // Başarı mesajını göster

                                    // Başarı mesajını 5 saniye sonra gizle
                                    setTimeout(function() {
                                        $('#responseMessage').fadeOut(); // Mesajı yavaşça gizle
                                    }, 5000); // 5000ms = 5 saniye

                                    var updatedValues = data.updated_values;
                                    var komponentRow = $('tr[data-komponent-id="' + data.komponent_id + '"]');

                                    var kategoriId = updatedValues.kategori_id.split(',')[0].trim();
                                    var paketId = updatedValues.paket_id.split(',')[0].trim();
                                    var lokasyonId = updatedValues.lokasyon_id.split(',')[0].trim();
                                    var ureticiId = updatedValues.uretici_id.split(',')[0].trim();
                                    var tedarikciId = updatedValues.tedarikci_id.split(',')[0].trim();

                                    // Kategoriyi ve diğer bilgileri güncelle
                                    komponentRow.find('.komponent-ad-text').text(updatedValues.komponent_ad);
                                    komponentRow.find('.komponent-ad-input').val(updatedValues.komponent_ad);
                                    komponentRow.find('.ek-bilgi-text').text(updatedValues.ek_bilgi);
                                    komponentRow.find('.alt-kategori-text').text(updatedValues.tam_kategori);
                                    komponentRow.find('.paket-text').text(updatedValues.tam_paket);
                                    komponentRow.find('.lokasyon-text').text(updatedValues.tam_lokasyon);
                                    komponentRow.find('.uretici-text').text(updatedValues.uretici_ad);
                                    komponentRow.find('.tedarikci-text').text(updatedValues.tedarikci_ad);

                                    var tamKategori = updatedValues.tam_kategori;
                                    var ilkKisim = tamKategori.includes('>') ? tamKategori.split('>')[0].trim() : tamKategori;
                                    komponentRow.find('.kategori-text').text(ilkKisim); // HATA DÜZELTİLDİ ✅

                                    // Kategori select elementini güncelle
                                    komponentRow.find('.alt-kategori-select').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == kategoriId) {
                                                $(this).prop('selected', true);
                                            }
                                        });
                                    });

                                    // Paket select elementini güncelle
                                    komponentRow.find('.paket-select').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == paketId) {
                                                $(this).prop('selected', true);
                                            }
                                        });
                                    });

                                    // Lokasyon select elementini güncelle
                                    komponentRow.find('.lokasyon-select').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == lokasyonId) {
                                                $(this).prop('selected', true);
                                            }
                                        });
                                    });

                                    // Üretici select elementini güncelle
                                    komponentRow.find('.uretici-select').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == ureticiId) {
                                                $(this).prop('selected', true);
                                            }
                                        });
                                    });

                                    // Tedarikçi select elementini güncelle
                                    komponentRow.find('.tedarikci-select').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == tedarikciId) {
                                                $(this).prop('selected', true);
                                            }
                                        });
                                    });

                                    // "komponent_ad" select öğesini güncelle
                                    komponentRow.find('select[name="komponent_adSelect"]').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == data.komponent_id) {
                                                $(this).text(updatedValues.komponent_ad);
                                            }
                                        });
                                    });

                                    // "ek_bilgi" select öğesini güncelle
                                    komponentRow.find('select[name="ek_bilgiSelect"]').each(function() {
                                        var selectElement = $(this);
                                        selectElement.find('option').each(function() {
                                            // "Seçiniz" seçeneği hariç diğer seçenekleri kontrol et
                                            if ($(this).val() !== "" && $(this).val() == data.komponent_id) {
                                                $(this).text(updatedValues.ek_bilgi);
                                            }
                                        });
                                    });

                                    // Modalı kapama (isteğe bağlı)
                                    $('#duzenleModal').modal('hide');
                                } else {
                                    $('#responseMessage').removeClass('alert-success').addClass('alert-danger');
                                    $('#responseMessage').text(data.message).show(); // Hata mesajını göster
                                    setTimeout(function() {
                                        $('#responseMessage').fadeOut(); // Mesajı yavaşça gizle
                                    }, 5000); // 5000ms = 5 saniye
                                }
                            },
                            error: function(xhr, status, error) {
                                console.log('Ajax isteği sırasında hata oluştu:', error); // Hata mesajını konsola yazdır
                                $('#responseMessage').removeClass('alert-success').addClass('alert-danger');
                                $('#responseMessage').text('Bir hata oluştu!').show();
                            }
                        });
                    });
// "ek_bilgi" select öğesini güncelle
                    komponentRow.find('select[name="ek_bilgiSelect"]').each(function() {
                        var selectElement = $(this);
                        console.log("Select Element:", selectElement); // select öğesini kontrol et
                        selectElement.find('option').each(function() {
                            var oldText = $(this).text();  // Eski metni al
                            var optionValue = $(this).val();  // Seçilen option değerini al
                            console.log("Ek Bilgi Option Değeri:", optionValue, "- Eski Değer:", oldText); // Konsola yazdır

                            if (optionValue == data.komponent_id) {
                                // Yeni metni ayarla ve konsola yazdır
                                console.log("Yeni Ek Bilgi:", data.updated_values.ek_bilgi);
                                $(this).text(data.updated_values.ek_bilgi);
                            }
                        });
                    });


                    // Modalı kapama (isteğe bağlı)
                    $('#duzenleModal').modal('hide');
                } else {
                    $('#responseMessage').removeClass('alert-success').addClass('alert-danger');
                    $('#responseMessage').text(data.message).show(); // Hata mesajını göster
                    setTimeout(function() {
                        $('#responseMessage').fadeOut(); // Mesajı yavaşça gizle
                    }, 5000); // 5000ms = 5 saniye
                }
            },
            error: function(xhr, status, error) {
                console.log('Ajax isteği sırasında hata oluştu:', error); // Hata mesajını konsola yazdır
                $('#responseMessage').removeClass('alert-success').addClass('alert-danger');
                $('#responseMessage').text('Bir hata oluştu!').show();
            }
        });
    });
</script>
