<?php
require_once 'inc/guvenlik.php';

$errors = [];
$data = [];

if (empty($_POST['ad'])) {
    $errors['ad'] = 'Zorunlu alan';
}

if (empty($_POST['ek_bilgi'])) {
    $errors['ek_bilgi'] = 'Zorunlu alan';
}

if (empty($_POST['lokasyon'])) {
    $errors['lokasyon'] = 'Zorunlu alan';
}

if (empty($_POST['uretici'])) {
    $errors['uretici'] = 'Zorunlu alan';
}

if (empty($_POST['paket'])) {
    $errors['paket'] = 'Zorunlu alan';
}

if (empty($_POST['tedarikci'])) {
    $errors['tedarikci'] = 'Zorunlu alan';
}

if (empty($_POST['kategori'])) {
    $errors['kategori'] = 'Zorunlu alan';
}

if (empty($_POST['adet'])) {
    $errors['adet'] = 'Zorunlu alan';
}

if (!empty($errors)) {
    $data['success'] = false;
    $data['errors'] = $errors;
} else {
    $data['success'] = true;
    $data['message'] = 'Eklendi!';

    // Verileri güvenli hale getir
    $ad = htmlspecialchars(trim($_POST['ad']));
    $ek_bilgi = htmlspecialchars(trim($_POST['ek_bilgi']));
    $lokasyon = htmlspecialchars(trim($_POST['lokasyon']));
    $uretici = htmlspecialchars(trim($_POST['uretici']));
    $paket = htmlspecialchars(trim($_POST['paket']));
    $tedarikci = htmlspecialchars(trim($_POST['tedarikci']));
    $kategori = htmlspecialchars(trim($_POST['kategori']));
    $adet = (int) $_POST['adet']; // Sayısal değer olduğundan emin olmak için dönüşüm
    $detaylar = htmlspecialchars($_POST['detaylar']);

    // Verilerin virgülden önceki ID'lerini al
    $lokasyon_id = explode(',', $lokasyon)[0];
    $uretici_id = explode(',', $uretici)[0];
    $paket_id = explode(',', $paket)[0];
    $tedarikci_id = explode(',', $tedarikci)[0];
    $kategori_id = explode(',', $kategori)[0];

    // Dosya yükleme işlemi
    if (isset($_FILES['gorsel'])) { // Dosya gönderildiyse
        $hedef_dizin = "uploads/";

        // Dosya adını güvenli hale getir
        $yuklenenDosya = basename($_FILES["gorsel"]["name"]);
        $DosyaUzantisi = strtolower(pathinfo($yuklenenDosya, PATHINFO_EXTENSION));

        // Geçerli dosya türleri ve boyut kontrolü
        $gecerliUzantilar = ['jpg', 'jpeg', 'png', 'gif'];
        $maxDosyaBoyutu = 5 * 1024 * 1024; // 5MB

        if (!in_array($DosyaUzantisi, $gecerliUzantilar)) {
            $errors['gorsel'] = 'Geçersiz dosya türü!';
        } elseif ($_FILES['gorsel']['size'] > $maxDosyaBoyutu) {
            $errors['gorsel'] = 'Dosya boyutu 5MB\'ı geçemez!';
        } else {
            // Dosya ismini güvenli hale getir
            $UzantiSil = explode('.', $yuklenenDosya);
            $UzantisizYeniDosyaAd = rand(0, 99999) . '_' . preg_replace("/[^a-zA-Z0-9\-_]/", "", $UzantiSil[0]); // Güvenli dosya ismi

            $yeni_hedef_dosya = $hedef_dizin . $UzantisizYeniDosyaAd . '.' . $DosyaUzantisi; // Yeni dosya adını belirleyelim

            // Dosya yüklemesini gerçekleştir
            if (move_uploaded_file($_FILES["gorsel"]["tmp_name"], $yeni_hedef_dosya)) {
                $gorsel = $yeni_hedef_dosya;

                // Komponent ekle
                $komponent_ekle = "INSERT INTO komponent (ad, ek_bilgi, lokasyon_id, uretici_id, paket_id, tedarikci_id, kategori_id, adet, gorsel, detaylar)
                        VALUES (:ad, :ek_bilgi, :lokasyon_id, :uretici_id, :paket_id, :tedarikci_id, :kategori_id, :adet, :gorsel, :detaylar)";
                $komponent_ekle = $baglantim->prepare($komponent_ekle);
                $komponent_ekle->execute([
                    "ad" => $ad,
                    "ek_bilgi" => $ek_bilgi,
                    "lokasyon_id" => $lokasyon_id,
                    "uretici_id" => $uretici_id,
                    "paket_id" => $paket_id,
                    "tedarikci_id" => $tedarikci_id,
                    "kategori_id" => $kategori_id,
                    "adet" => $adet,
                    "gorsel" => $gorsel,
                    "detaylar" => $detaylar
                ]);

                // Komponent ekleme sonucunu mesaj olarak ver
                if ($komponent_ekle->rowCount() > 0) {
                    $data['success'] = true;
                    $data['message'] = 'Veritabanına Eklendi!';
                } else {
                    $data['success'] = false;
                    $data['errors'] = $errors;
                }
            } else {
                $data['success'] = false;
                $data['errors'] = ['gorsel' => 'Dosya yüklenemedi!'];
            }
        }
    }

    // Görsel olmadan ekleme
    if (!isset($_FILES['gorsel']) || !empty($errors['gorsel'])) {
        $komponent_ekle = "INSERT INTO komponent (ad, ek_bilgi, lokasyon_id, uretici_id, paket_id, tedarikci_id, kategori_id, adet, detaylar)
                        VALUES (:ad, :ek_bilgi, :lokasyon_id, :uretici_id, :paket_id, :tedarikci_id, :kategori_id, :adet, :detaylar)";
        $komponent_ekle = $baglantim->prepare($komponent_ekle);
        $komponent_ekle->execute([
            "ad" => $ad,
            "ek_bilgi" => $ek_bilgi,
            "lokasyon_id" => $lokasyon_id,
            "uretici_id" => $uretici_id,
            "paket_id" => $paket_id,
            "tedarikci_id" => $tedarikci_id,
            "kategori_id" => $kategori_id,
            "adet" => $adet,
            "detaylar" => $detaylar
        ]);

        // Komponent ekleme sonucunu mesaj olarak ver
        if ($komponent_ekle->rowCount() > 0) {
            $data['success'] = true;
            $data['message'] = 'Başarılı!';
        } else {
            $data['success'] = false;
            $data['errors'] = $errors;
            $data['message2'] = 'Değişiklik olmadı!';
        }
    }
}

echo json_encode($data);
?>
