<?php
require_once 'inc/guvenlik.php'; // Güvenlik dosyasının dahil edilmesi

// XSS koruması için htmlentities kullanılır.
function temizle($veri) {
    return htmlspecialchars($veri, ENT_QUOTES, 'UTF-8');
}

?>

<h5>Ürün Ekle</h5>
<form id="ekleme" class="row g-0 mb-5" action="komponent-ekleDB.php" method="post" enctype="multipart/form-data">
    <div id="ad_1" class="col-md-6 form-select-sm">
        <label for="ad" class="form-label">Ürün Adı</label>
        <input type="text" name="ad" class="form-control form-select-sm input_ad" id="ad" autofocus required>
    </div>

    <div id="ek_bilgi1" class="col-md-4 form-select-sm">
        <label for="ek_bilgi" class="form-label">Ek Bilgi</label>
        <input type="text" name="ek_bilgi" class="form-control form-select-sm" id="ek_bilgi" value="<?php echo isset($_POST['ek_bilgi']) ? temizle($_POST['ek_bilgi']) : ''; ?>">
    </div>

    <div id="adet1" class="col-md-2 form-select-sm">
        <label for="adet" class="form-label">Adet</label>
        <input type="number" name="adet" class="form-control form-select-sm" id="adet" required min="1">
    </div>

    <!-- KATEGORİ ÇEKME BÖLÜMÜ -->
    <div id="kategori1" class="col-md-4 form-select-sm">
        <label for="kategori" class="form-label">Kategori</label>
        <?php
        try {
            $kategori = "WITH RECURSIVE cte AS
            (
              SELECT id, CAST(ad AS CHAR(200)) AS ad,
                     CAST(ad AS CHAR(200)) AS yol,
                     CAST(ad AS CHAR(200)) AS path,
                     0 as derinlik
              FROM kategori WHERE kategori_id = 0
              UNION ALL
              SELECT c.id,
                     CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
                     CONCAT(cte.path, ' > ', c.ad),
                     CONCAT(cte.yol, ' > ', c.ad),
                     cte.derinlik+1
              FROM kategori c JOIN cte ON
              cte.id=c.kategori_id
            )
            SELECT * FROM cte ORDER BY path;";
            $kategori_sonuc = $baglantim->query($kategori);
            $kategori_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="kategori" id="kategori" class="form-select form-select-sm" size="10" required>';

        while ($kategori_satir = $kategori_sonuc->fetch()) {
            $silinecek_cizgi = $kategori_satir['ad']; // Gereksiz çizgileri ve boşlukları sil
            $cizgi_sil = str_replace(' - ', '', $silinecek_cizgi);

            echo '<option value="' . $kategori_satir['id'] . ',' . $kategori_satir['yol'] . '" title="' . $cizgi_sil . '">' . temizle($kategori_satir['ad']) . '</option>';
        }
        echo '</select>';
        ?>
    </div>
    <!-- KATEGORİ ÇEKME BÖLÜMÜ -->

    <!-- PAKET ÇEKME BÖLÜMÜ -->
    <div id="paket1" class="col-md-4 form-select-sm">
        <label for="paket" class="form-label">Paket</label>
        <?php
        try {
            $paket = "WITH RECURSIVE cte AS
            (
              SELECT id, CAST(ad AS CHAR(200)) AS ad,
                     CAST(ad AS CHAR(200)) AS yol,
                     CAST(ad AS CHAR(200)) AS path,
                     0 as derinlik
              FROM paket WHERE paket_id = 0
              UNION ALL
              SELECT c.id,
                     CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
                     CONCAT(cte.path, ' > ', c.ad),
                     CONCAT(cte.yol, ' > ', c.ad),
                     cte.derinlik+1
              FROM paket c JOIN cte ON
              cte.id=c.paket_id
            )
            SELECT * FROM cte ORDER BY path;";
            $paket_sonuc = $baglantim->query($paket);
            $paket_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="paket" id="paket" class="form-select form-select-sm" size="10" required>';
        while ($paket_satir = $paket_sonuc->fetch()) {
            $silinecek_cizgi = $paket_satir['ad']; // Gereksiz çizgileri ve boşlukları sil
            $cizgi_sil = str_replace(' - ', '', $silinecek_cizgi);

            echo '<option value="' . $paket_satir['id'] . ',' . $paket_satir['yol'] . '" title="' . $cizgi_sil . '">' . temizle($paket_satir['ad']) . '</option>';
        }
        echo '</select>';
        ?>
    </div>
    <!-- PAKET ÇEKME BÖLÜMÜ -->

    <!-- ÜRETİCİ ÇEKME BÖLÜMÜ -->
    <div id="uretici1" class="col-md-4 form-select-sm">
        <label for="uretici" class="form-label">Üretici</label>
        <?php
        try {
            $uretici = "select id, ad from uretici ORDER BY ad ASC";
            $uretici_sonuc = $baglantim->query($uretici);
            $uretici_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="uretici" id="uretici" class="form-select form-select-sm" size="10" required>';

        while ($uretici_satir = $uretici_sonuc->fetch()) {
            echo '<option value="' . $uretici_satir['id'] . ',' . $uretici_satir['ad'] . '">' . temizle($uretici_satir['ad']) . '</option>';
        }
        echo '</select>';
        ?>
    </div>
    <!-- ÜRETİCİ ÇEKME BÖLÜMÜ -->

    <!-- TEDARİKÇİ ÇEKME BÖLÜMÜ -->
    <div id="tedarikci1" class="col-md-4 form-select-sm">
        <label for="tedarikci" class="form-label">Tedarikçi</label>
        <?php
        try {
            $tedarikci = "select id, ad from tedarikci ORDER BY ad ASC";
            $tedarikci_sonuc = $baglantim->query($tedarikci);
            $tedarikci_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="tedarikci" id="tedarikci" class="form-select form-select-sm" size="10" required>';

        while ($tedarikci_satir = $tedarikci_sonuc->fetch()) {
            echo '<option value="' . $tedarikci_satir['id'] . ',' . $tedarikci_satir['ad'] . '">' . temizle($tedarikci_satir['ad']) . '</option>';
        }
        echo '</select>';
        ?>
    </div>
    <!-- TEDARİKÇİ ÇEKME BÖLÜMÜ -->

    <!-- LOKASYON ÇEKME BÖLÜMÜ -->
    <div id="lokasyon1" class="col-md-4 form-select-sm">
        <label for="lokasyon" class="form-label">Lokasyon</label>
        <?php
        try {
            $lokasyon = "WITH RECURSIVE cte AS
            (
              SELECT id, CAST(ad AS CHAR(200)) AS ad,
                     CAST(ad AS CHAR(200)) AS yol,
                     CAST(ad AS CHAR(200)) AS path,
                     0 as derinlik
              FROM lokasyon WHERE lokasyon_id = 0
              UNION ALL
              SELECT c.id,
                     CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
                     CONCAT(cte.path, ' > ', c.ad),
                     CONCAT(cte.yol, ' > ', c.ad),
                     cte.derinlik+1
              FROM lokasyon c JOIN cte ON
              cte.id=c.lokasyon_id
            )
            SELECT * FROM cte ORDER BY path;";
            $lokasyon_sonuc = $baglantim->query($lokasyon);
            $lokasyon_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }

        echo '<select name="lokasyon" id="lokasyon" class="form-select form-select-sm" size="10" required>';

        while ($lokasyon_satir = $lokasyon_sonuc->fetch()) {
            $silinecek_cizgi = $lokasyon_satir['ad']; // Gereksiz çizgileri ve boşlukları sil
            $cizgi_sil = str_replace(' - ', '', $silinecek_cizgi);

            echo '<option value="' . $lokasyon_satir['id'] . ',' . $lokasyon_satir['yol'] . '" title="' . $cizgi_sil . '">' . temizle($lokasyon_satir['ad']) . '</option>';
        }
        echo '</select>';
        ?>
    </div>

    <div id="tags1" class="col-4 form-select-sm">
        <label for="tags" class="form-label">Tags</label>
        <input type="text" name="tags" class="form-control form-select-sm" id="tags" value="<?php echo isset($_POST['tags']) ? temizle($_POST['tags']) : ''; ?>">
    </div>

    <div id="detaylar1" class="col-12 form-select-sm">
        <label for="detaylar" class="col-md-4 form-select-sm">Detaylar</label>
        <textarea class="form-control form-select-sm" name="detaylar" placeholder="Detaylari giriniz" id="detaylar"><?php echo isset($_POST['detaylar']) ? temizle($_POST['detaylar']) : ''; ?></textarea>
    </div>

    <div class="col-6 text-first">
        <span id="EklemeMesaji"></span>
    </div>

    <div class="col-12 text-end">
        <button type="submit" class="btn btn-primary btn-sm">Kaydet</button>
    </div>
</form>
