<?php
require_once 'inc/guvenlik.php'; // Güvenlik dosyasını dahil et

// Lokasyon düzenleme ID'si güvenli hale getiriliyor
$DuzenlemeID = isset($_GET['LokasyonDuzenleID']) ? (int) $_GET['LokasyonDuzenleID'] : 0; // Sayısal olmalı

if ($DuzenlemeID > 0) {
    // SQL Injection'dan korunmak için prepared statement kullanılacak
    $kd = $baglantim->prepare("SELECT * FROM lokasyon WHERE id = :id");
    $kd->bindParam(':id', $DuzenlemeID, PDO::PARAM_INT); // Parametreyi bağla
    $kd->execute();
    $kds = $kd->fetch();
}
?>
<h5>Lokasyon Düzenle</h5>
<form id="lokasyon_duzenle" class="row g-3" action="lokasyon-duzenleDB.php" method="post">
    <div id="ad_2" class="col-md-6 form-select-sm">
        <label for="ad22" class="form-label">Yeni Ad</label>
        <input type="text" name="ad22" class="form-control form-select-sm input_ad2" id="ad22" value="<?php echo htmlspecialchars($kds['ad']); ?>"  <!-- XSS korunması için htmlspecialchars() kullanıldı -->
    </div>
    <input id="KategoriDuzenleID" type="hidden" name="KategoriDuzenleID" value="<?php echo $DuzenlemeID; ?>">

    <!-- KATEGORİ ÇEKME BÖLÜMÜ -->
    <div id="kategori_2" class="col-md-6 form-select-sm">
        <label for="kategori2" class="form-label">Lokasyon Ağacındaki Konumu</label>
        <?php
        try {
            // Recursive Query
            $kategori = "WITH RECURSIVE cte AS
(
  SELECT id, CAST(ad AS CHAR(200)) AS ad,
         CAST(ad AS CHAR(200)) AS yol,
         CAST(ad AS CHAR(200)) AS path,
         CAST(lokasyon_id AS CHAR(200)) AS katID,
         0 as derinlik
  FROM lokasyon WHERE lokasyon_id = 0
  UNION ALL
  SELECT c.id,
         CONCAT(REPEAT(' - ', cte.derinlik+1), c.ad),
         CONCAT(cte.path, ' > ', c.ad),
         CONCAT(cte.yol, ',', c.ad),
         CONCAT(cte.id),
         cte.derinlik+1
  FROM lokasyon c JOIN cte ON
  cte.id=c.lokasyon_id
)
SELECT * FROM cte ORDER BY path;";
            $kategori_sonuc = $baglantim->query($kategori);
            $kategori_sonuc->setFetchMode(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            die("Veri çekilirken bir problem oluştu !!!" . $e->getMessage());
        }
        echo '<select name="kategori2" id="kategori2" class="form-select form-select-sm" size="20">';

        while ($kategori_satir = $kategori_sonuc->fetch()) {
            $id = explode(',', $DuzenlemeID)[0]; // set edilecek id

            if ($id == $kategori_satir['id']) {
                $isaretle = "selected='selected'";
                $devredisi = '';
            } else {
                $isaretle = '';
                $devredisi = "disabled='disabled'";
            }

            // Çizgileri temizle ve XSS önlemi
            $silinecek_cizgi = htmlspecialchars($kategori_satir['ad']);
            ?>
            <option value="<?= htmlspecialchars($kategori_satir['id'] . ',' . $kategori_satir['yol']) ?>" <?php echo $devredisi . $isaretle; ?>><?= $silinecek_cizgi ?></option>
        <?php }
        echo '</select>';
        ?>
    </div>
    <!-- KATEGORİ ÇEKME BÖLÜMÜ -->

    <div class="col-6 text-first">
        <span id="DuzenleMesaji"></span>
    </div>
    <div class="col-6 text-end">
        <button type="submit" class="btn btn-primary btn-sm">Kaydet</button>
    </div>
</form>
