<?php
require_once 'inc/guvenlik.php';

$errors = [];
$data = [];

// Zorunlu alanları kontrol et
if (empty($_POST['ad22'])) {
    $errors['ad22'] = 'Zorunlu alan';
}
if (empty($_POST['kategori2'])) {
    $errors['kategori2'] = 'Zorunlu alan';
}

if (!empty($errors)) {
    $data['success'] = false;
    $data['errors'] = $errors;
} else {
    $data['success'] = true;
    $data['message'] = 'Eklendi!';

    // POST verilerini temizle
    $KategoriDuzenleID = isset($_POST['PaketDuzenleID']) ? (int)$_POST['PaketDuzenleID'] : 0; // Tip güvenliği
    $ad22 = isset($_POST['ad22']) ? trim($_POST['ad22']) : '';
    $kategori2 = isset($_POST['kategori2']) ? $_POST['kategori2'] : '';

    // Güvenlik için parametreli sorgu kullan
    $id = explode(',', $kategori2)[0]; // set edilecek id

    // Sorguyu hazırlayalım (SQL Injection koruması)
    $sql = "UPDATE paket SET ad = :ad WHERE id = :id";
    $kategori_duzenle = $baglantim->prepare($sql);

    // Parametreleri bağla
    $kategori_duzenle->bindParam(':ad', $ad22, PDO::PARAM_STR);
    $kategori_duzenle->bindParam(':id', $id, PDO::PARAM_INT);

    // Sorguyu çalıştır
    $kategori_duzenle->execute();

    // Sorgu sonucunu kontrol et
    if ($kategori_duzenle->rowCount() > 0) {
        $data['success'] = true;
        $data['message'] = 'Kayıt Başarılı!';
    } else {
        $data['success'] = false;
        $data['errors'] = $errors;
        $data['message2'] = 'Değişiklik olmadı!';
    }
}

echo json_encode($data);