<?php
require_once 'inc/guvenlik.php';

$errors = [];
$data = [];

if (empty($_POST['paketAd'])) {
    $errors['paketAd'] = 'Zorunlu alan';
}

if (!empty($errors)) {
    $data['success'] = false;
    $data['errors'] = $errors;
} else {
    $data['success'] = true;
    $data['message'] = 'Eklendi!';

    // Kullanıcıdan alınan "paketAd" verisini temizle ve doğrula
    $ad = $_POST['paketAd'];
    $ad = trim($ad);  // Boşlukları temizle

    // "paketler" alanı kontrolü
    if (isset($_POST['paketler']) && !empty($_POST['paketler'])) {
        $kategori2 = $_POST['paketler'];
        // verilerin virgulden önceki id'yi al
        $id = explode(',', $kategori2)[0]; // set edilecek id
    } else {
        $id = 0;
    }

    // SQL Injection'a karşı koruma: Prepared Statements kullanarak güvenli sorgu
    try {
        $kategori_ekle_sql = "INSERT INTO paket (ad, paket_id)
                              VALUES (:ad, :paket_id)";
        $kategori_ekle = $baglantim->prepare($kategori_ekle_sql);
        $kategori_ekle->execute([
            ':ad' => $ad,
            ':paket_id' => $id
        ]);

        // Kayıt başarılıysa, mesajı döndür
        if ($kategori_ekle->rowCount() > 0) {
            $data['success'] = true;
            $data['message'] = 'Veritabanına Eklendi!';
        } else {
            $data['success'] = false;
            $data['message'] = 'Kayıt işlemi başarısız!';
        }

    } catch (PDOException $e) {
        // Veritabanı hatası durumunda, hata mesajı döndür
        $data['success'] = false;
        $data['message'] = 'Veritabanı hatası: ' . $e->getMessage();
    }
}

echo json_encode($data);
?>