<?php
require_once 'inc/guvenlik.php';

// rekursif sil
function rekursifSil($id, $baglantim)
{
    $baglan2 = $baglantim;

    // ID'yi integer olarak doğrulamak ve temizlemek
    $id = (int)$id; // Güvenli integer dönüşümü

    // Güvenli SQL sorgusu için Prepared Statements kullanıyoruz
    $sorgu = $baglantim->prepare("SELECT * FROM paket WHERE paket_id = :id");
    $sorgu->execute(['id' => $id]);

    if ($sorgu->rowCount() > 0) {
        while ($simdiki = $sorgu->fetch(PDO::FETCH_ASSOC)) {
            rekursifSil($simdiki['id'], $baglan2);
        }
    }

    // Silme işlemini güvenli bir şekilde yapıyoruz
    $silSorgu = $baglantim->prepare("DELETE FROM paket WHERE id = :id");
    $silSorgu->execute(['id' => $id]);
}

// Veritabanına güvenli bir şekilde veri gönderirken, ID'yi doğrulayıp temizliyoruz
if (isset($_POST['id'])) {
    $id = (int)$_POST['id'];  // ID'yi integer olarak temizliyoruz
    rekursifSil($id, $baglantim);
}

?>
