<?php
// Veritabanı bağlantısı
require_once 'inc/baglan.php';

// Token'ı URL'den alıyoruz
if (isset($_GET['token'])) {
    $token = $_GET['token'];

    // Token'ı veritabanında kontrol ediyoruz
    $query = "SELECT * FROM uye WHERE parolaunuttum = :token AND aktif = 1";
    $stmt = $baglantim->prepare($query);
    $stmt->bindParam(':token', $token, PDO::PARAM_STR);
    $stmt->execute();

    // Eğer token bulunursa, şifre sıfırlama formunu gösteriyoruz
    if ($stmt->rowCount() > 0) {
        // Token geçerli, şifre sıfırlama işlemi başladı
        if (isset($_POST['parola'])) {
            // Şifreyi alıyoruz
            $yeniParola = $_POST['parola'];
            $hashliParola = password_hash($yeniParola, PASSWORD_BCRYPT);

            // Yeni şifreyi veritabanına kaydediyoruz
            $updateQuery = "UPDATE uye SET parola = :parola, parolaunuttum = NULL WHERE parolaunuttum = :token";
            $updateStmt = $baglantim->prepare($updateQuery);
            $updateStmt->bindParam(':parola', $hashliParola);
            $updateStmt->bindParam(':token', $token);
            $updateStmt->execute();

            // Şifre başarıyla sıfırlandı, kullanıcıya giriş yapmasını hatırlatıyoruz
            echo '<div class="alert alert-success">Parolanız başarıyla sıfırlanmıştır. Şimdi <a href="giris.php">giriş yapabilirsiniz</a>.</div>';

            // İsteğe bağlı: Kullanıcıyı yönlendirebilirsiniz
            // header("Location: login.php");
            // exit;
        } else {
            // Şifre sıfırlama formunu göster
            ?>
            <!-- Şifre sıfırlama formu -->
            <form method="POST" action="">
                <div class="form-group">
                    <label for="parola">Yeni Parola:</label>
                    <input type="password" name="parola" class="form-control" required>
                </div>
                <button type="submit" class="btn btn-primary">Parolayı Sıfırla</button>
            </form>
            <?php
        }
    } else {
        echo '<div class="alert alert-danger">Geçersiz veya süresi dolmuş bir bağlantıya tıkladınız.</div>';
    }
} else {
    echo '<div class="alert alert-danger">Geçersiz bağlantı.</div>';
}
?>
