<?php
require_once 'inc/guvenlik.php';

if (isset($_GET['query'])) {
    // Gelen veriyi temizle (XSS için)
    $query = trim($_GET['query']);
    $query = htmlspecialchars($query, ENT_QUOTES, 'UTF-8'); // XSS için güvenli hale getirir

    // Parametreli sorgu kullanarak SQL Injection'ı engelle
    $sql = "SELECT id, ad FROM komponent WHERE ad LIKE :query LIMIT 10";
    $stmt = $baglantim->prepare($sql);

    // Sorguya parametreyi güvenli şekilde ekleyelim
    $stmt->execute([':query' => "%$query%"]);

    // Veritabanından gelen sonuçları alalım
    $components = $stmt->fetchAll(PDO::FETCH_ASSOC);

    // JSON olarak döndür
    echo json_encode($components);
}
?>
