<?php
require_once 'inc/guvenlik.php';

$errors = [];
$data = [];

// Ad alanının boş olup olmadığını kontrol etme
if (empty($_POST['ad22'])) {
    $errors['ad22'] = 'Zorunlu alan';
}

if (!empty($errors)) {
    $data['success'] = false;
    $data['errors'] = $errors;
} else {
    $data['success'] = true;
    $data['message'] = 'Eklendi!';

    // POST verilerini güvenli bir şekilde alalım
    $KategoriDuzenleID = isset($_POST['TedarikciDuzenleID']) ? (int)$_POST['TedarikciDuzenleID'] : 0; // ID'nin sayısal olup olmadığını kontrol et
    $ad22 = isset($_POST['ad22']) ? trim($_POST['ad22']) : ''; // Boşlukları temizle

    // Eğer ID geçerli değilse, işlem yapma
    if ($KategoriDuzenleID <= 0) {
        $data['success'] = false;
        $data['message'] = 'Geçersiz ID!';
    } else {
        // SQL sorgusunu güvenli bir şekilde hazırlayalım
        $kategori_duzenle = "UPDATE tedarikci SET ad = :ad WHERE id = :id";

        try {
            // Prepared statement ile veritabanında işlem yapma
            $stmt = $baglantim->prepare($kategori_duzenle);
            $stmt->bindParam(':ad', $ad22, PDO::PARAM_STR); // Ad parametresi
            $stmt->bindParam(':id', $KategoriDuzenleID, PDO::PARAM_INT); // ID parametresi
            $stmt->execute();

            // Sonuç kontrolü
            if ($stmt->rowCount() > 0) {
                $data['success'] = true;
                $data['message'] = 'Kayıt Başarılı!';
            } else {
                $data['success'] = false;
                $data['message2'] = 'Değişiklik olmadı!';
            }
        } catch (PDOException $e) {
            // Hata durumunda mesaj
            $data['success'] = false;
            $data['message2'] = 'Veritabanı hatası: ' . $e->getMessage();
        }
    }
}

echo json_encode($data);