<?php
require_once 'inc/guvenlik.php';

$errors = [];
$data = [];

// Veriyi alırken temizleme ve doğrulama
if (empty($_POST['ureticiEkleAd'])) {
    $errors['ureticiEkleAd'] = 'Zorunlu alan';
} else {
    // Veriyi temizle (Trim yaparak baştaki ve sondaki boşlukları kaldır)
    $ad = trim($_POST['ureticiEkleAd']);

    // Adın uzunluğunu kontrol et, boş olmamalı
    if (strlen($ad) < 2) {
        $errors['ureticiEkleAd'] = 'Üretici adı en az 2 karakter olmalıdır.';
    }
}

if (!empty($errors)) {
    // Hata varsa, yanıtı false olarak döndür
    $data['success'] = false;
    $data['errors'] = $errors;
} else {
    // Veritabanına ekleme işlemi
    try {
        $kategori_ekle = "INSERT INTO uretici (ad) VALUES (:ad)";
        $kategori_ekle_stmt = $baglantim->prepare($kategori_ekle);

        // Veriyi güvenli şekilde ekle
        $kategori_ekle_stmt->execute(array(
            "ad" => $ad
        ));

        // İşlem başarılıysa, başarı mesajı döndür
        if ($kategori_ekle_stmt->rowCount() > 0) {
            $data['success'] = true;
            $data['message'] = 'Üretici başarıyla veritabanına eklendi!';
        } else {
            $data['success'] = false;
            $data['message'] = 'Bir hata oluştu. Lütfen tekrar deneyin.';
        }
    } catch (PDOException $e) {
        // PDO hata yönetimi
        $data['success'] = false;
        $data['message'] = 'Veritabanı hatası: ' . $e->getMessage();
    }
}

echo json_encode($data);